<?php

declare(strict_types=1);

namespace Rowlinson\Api\Credentials;

use Illuminate\Contracts\Session\Session;

/**
 * Store the API key in the session
 */
class SessionApiKeyStorage implements ApiKeyStorageInterface
{
    private const SESSION_KEY = 'rowlinsons_api_key';
    protected Session $session;

    public function __construct(Session $session)
    {
        $this->session = $session;
    }

    /**
     * {@inheritDoc}
     */
    public function store(string $apiKey): void
    {
        $this->session->put(self::SESSION_KEY, $apiKey);
    }

    /**
     * {@inheritDoc}
     */
    public function retrieve(): ?string
    {
        return $this->session->get(self::SESSION_KEY, null);
    }
}
