<?php

declare(strict_types=1);

namespace Rowlinson\Api;

use Illuminate\Support\Collection;
use Rowlinson\Api\Responses\Invites\InviteResponse;

use function collect;

class InviteClient extends AbstractClient
{
    /**
     * List all pending invites
     *
     * @return Collection<InviteResponse>
     */
    public function listAll(): Collection
    {
        $response = $this->get('users/invites');

        $invites = $this->serializer->deserialize(
            (string)$response->getBody(),
            'array<' . InviteResponse::class . '>', // @phpstan-ignore-line
            'json'
        );

        return collect($invites);
    }
}
